#include <iostream>
#include <vector>

class A {
public:
	A() : a {0}, b {0}
	{}
	
	A(int a, int b) : a {a}, b {b}
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
	
	// Copy-Constructor
	A(const A& ob) : a {ob.a}, b {ob.b}
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
	
	~A()
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
private:
	int a, b;
};

int main()
{
	std::vector<A> v;
//	v.push_back(A(10, 20));
//	v.push_back({10, 20});

	v.emplace_back(10, 30);
}
