#include <iostream>

class A {
public:
	A() : a {0}, b {0}
	{}
	
	A(int a, int b) : a {a}, b {b}
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
	
	// Copy-Constructor
	A(const A& ob) : a {ob.a}, b {ob.b}
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
	
	~A()
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
private:
	int a, b;
};

int main()
{
	A a {2, 3};
	
	// Obiecte construite prin copiere
	A b = a;
	A c (a);
	A d {a};
}
