// Right Value Reference (&&)
#include <iostream>


class A {
public:
	A() {}
	
	// Copy Constructor
	A(const A&)
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}
	
	// Move Copy-Constructor
	A(A&&)
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
	}

	// Assignment Operator
	A& operator = (const A& )
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
		return *this;
	}
	
	// Move Assignment Operator
	A& operator = (A&& )
	{
		std::cout << __PRETTY_FUNCTION__ << '\n';
		return *this;
	}
	
};

int main()
{
	A a;
	
//	A b = a;
//	A c = std::move(a);
	
//	a = b;
//	a = std::move(b);
	
	a = A();
	
    return 0;
}
